Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4670)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4671)
@@ -1541,8 +1493,8 @@
 !
 !--             Array of heat flux from indoor ground (wall, roof, land)
-                IF ( l == -1 )  THEN
-                   IF ( .NOT.  ALLOCATED( surf_usm_h%iwghf_eb_av ) )  THEN
-                       ALLOCATE ( surf_usm_h%iwghf_eb_av(1:surf_usm_h%ns) )
-                       surf_usm_h%iwghf_eb_av = 0.0_wp
+                IF ( horizontal )  THEN
+                   IF ( .NOT.  ALLOCATED( surf_usm_h(l)%iwghf_eb_av ) )  THEN
+                       ALLOCATE ( surf_usm_h(l)%iwghf_eb_av(1:surf_usm_h(l)%ns) )
+                       surf_usm_h(l)%iwghf_eb_av = 0.0_wp
                    ENDIF
                 ELSE
@@ -1556,8 +1508,8 @@
 !
 !--             Array of heat flux from indoor window ground (wall, roof, land)
-                IF ( l == -1 ) THEN
-                   IF ( .NOT.  ALLOCATED( surf_usm_h%iwghf_eb_window_av ) )  THEN
-                       ALLOCATE ( surf_usm_h%iwghf_eb_window_av(1:surf_usm_h%ns) )
-                       surf_usm_h%iwghf_eb_window_av = 0.0_wp
+                IF ( horizontal ) THEN
+                   IF ( .NOT.  ALLOCATED( surf_usm_h(l)%iwghf_eb_window_av ) )  THEN
+                       ALLOCATE ( surf_usm_h(l)%iwghf_eb_window_av(1:surf_usm_h(l)%ns) )
+                       surf_usm_h(l)%iwghf_eb_window_av = 0.0_wp
                    ENDIF
                 ELSE
@@ -1571,8 +1523,8 @@
 !
 !--             Surface temperature for surfaces
-                IF ( l == -1 )  THEN
-                   IF ( .NOT.  ALLOCATED( surf_usm_h%t_surf_wall_av ) )  THEN
-                       ALLOCATE ( surf_usm_h%t_surf_wall_av(1:surf_usm_h%ns) )
-                       surf_usm_h%t_surf_wall_av = 0.0_wp
+                IF ( horizontal )  THEN
+                   IF ( .NOT.  ALLOCATED( surf_usm_h(l)%t_surf_wall_av ) )  THEN
+                       ALLOCATE ( surf_usm_h(l)%t_surf_wall_av(1:surf_usm_h(l)%ns) )
+                       surf_usm_h(l)%t_surf_wall_av = 0.0_wp
                    ENDIF
                 ELSE
@@ -1586,8 +1538,8 @@
 !
 !--             Surface temperature for window surfaces
-                IF ( l == -1 )  THEN
-                   IF ( .NOT.  ALLOCATED( surf_usm_h%t_surf_window_av ) )  THEN
-                       ALLOCATE ( surf_usm_h%t_surf_window_av(1:surf_usm_h%ns) )
-                       surf_usm_h%t_surf_window_av = 0.0_wp
+                IF ( horizontal )  THEN
+                   IF ( .NOT.  ALLOCATED( surf_usm_h(l)%t_surf_window_av ) )  THEN
+                       ALLOCATE ( surf_usm_h(l)%t_surf_window_av(1:surf_usm_h(l)%ns) )
+                       surf_usm_h(l)%t_surf_window_av = 0.0_wp
                    ENDIF
                 ELSE
@@ -1601,8 +1553,8 @@
 !
 !--             Surface temperature for green surfaces
-                IF ( l == -1 )  THEN
-                   IF ( .NOT.  ALLOCATED( surf_usm_h%t_surf_green_av ) )  THEN
-                       ALLOCATE ( surf_usm_h%t_surf_green_av(1:surf_usm_h%ns) )
-                       surf_usm_h%t_surf_green_av = 0.0_wp
+                IF ( horizontal )  THEN
+                   IF ( .NOT.  ALLOCATED( surf_usm_h(l)%t_surf_green_av ) )  THEN
+                       ALLOCATE ( surf_usm_h(l)%t_surf_green_av(1:surf_usm_h(l)%ns) )
+                       surf_usm_h(l)%t_surf_green_av = 0.0_wp
                    ENDIF
                 ELSE
@@ -1616,8 +1568,8 @@
 !
 !--             Near surface (10cm) temperature for whole surfaces
-                IF ( l == -1 )  THEN
-                   IF ( .NOT.  ALLOCATED( surf_usm_h%pt_10cm_av ) )  THEN
-                       ALLOCATE ( surf_usm_h%pt_10cm_av(1:surf_usm_h%ns) )
-                       surf_usm_h%pt_10cm_av = 0.0_wp
+                IF ( horizontal )  THEN
+                   IF ( .NOT.  ALLOCATED( surf_usm_h(l)%pt_10cm_av ) )  THEN
+                       ALLOCATE ( surf_usm_h(l)%pt_10cm_av(1:surf_usm_h(l)%ns) )
+                       surf_usm_h(l)%pt_10cm_av = 0.0_wp
                    ENDIF
                 ELSE
@@ -1631,8 +1583,8 @@
 !
 !--             Wall temperature for iwl layer of walls and land
-                IF ( l == -1 )  THEN
-                   IF ( .NOT.  ALLOCATED( surf_usm_h%t_wall_av ) )  THEN
-                       ALLOCATE ( surf_usm_h%t_wall_av(nzb_wall:nzt_wall,1:surf_usm_h%ns) )
-                       surf_usm_h%t_wall_av = 0.0_wp
+                IF ( horizontal )  THEN
+                   IF ( .NOT.  ALLOCATED( surf_usm_h(l)%t_wall_av ) )  THEN
+                       ALLOCATE ( surf_usm_h(l)%t_wall_av(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns) )
+                       surf_usm_h(l)%t_wall_av = 0.0_wp
                    ENDIF
                 ELSE
@@ -1646,8 +1598,8 @@
 !
 !--             Window temperature for iwl layer of walls and land
-                IF ( l == -1 )  THEN
-                   IF ( .NOT.  ALLOCATED( surf_usm_h%t_window_av ) )  THEN
-                       ALLOCATE ( surf_usm_h%t_window_av(nzb_wall:nzt_wall,1:surf_usm_h%ns) )
-                       surf_usm_h%t_window_av = 0.0_wp
+                IF ( horizontal )  THEN
+                   IF ( .NOT.  ALLOCATED( surf_usm_h(l)%t_window_av ) )  THEN
+                       ALLOCATE ( surf_usm_h(l)%t_window_av(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns) )
+                       surf_usm_h(l)%t_window_av = 0.0_wp
                    ENDIF
                 ELSE
@@ -1661,8 +1613,8 @@
 !
 !--             Green temperature for iwl layer of walls and land
-                IF ( l == -1 )  THEN
-                   IF ( .NOT.  ALLOCATED( surf_usm_h%t_green_av ) )  THEN
-                       ALLOCATE ( surf_usm_h%t_green_av(nzb_wall:nzt_wall,1:surf_usm_h%ns) )
-                       surf_usm_h%t_green_av = 0.0_wp
+                IF ( horizontal )  THEN
+                   IF ( .NOT.  ALLOCATED( surf_usm_h(l)%t_green_av ) )  THEN
+                       ALLOCATE ( surf_usm_h(l)%t_green_av(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns) )
+                       surf_usm_h(l)%t_green_av = 0.0_wp
                    ENDIF
                 ELSE
@@ -1675,7 +1627,7 @@
 !
 !--             Soil water content for iwl layer of walls and land
-                IF ( l == -1 .AND. .NOT.  ALLOCATED( surf_usm_h%swc_av ) )  THEN
-                    ALLOCATE ( surf_usm_h%swc_av(nzb_wall:nzt_wall,1:surf_usm_h%ns) )
-                    surf_usm_h%swc_av = 0.0_wp
+                IF ( horizontal .AND. .NOT.  ALLOCATED( surf_usm_h(l)%swc_av ) )  THEN
+                    ALLOCATE ( surf_usm_h(l)%swc_av(nzb_wall:nzt_wall,1:surf_usm_h(l)%ns) )
+                    surf_usm_h(l)%swc_av = 0.0_wp
                 ELSE
                    IF ( .NOT.  ALLOCATED( surf_usm_v(l)%swc_av ) )  THEN
@@ -1697,7 +1649,7 @@
 !
 !--             Array of sensible heat flux from surfaces (land, roof, wall)
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%wshf_eb_av(m) = surf_usm_h%wshf_eb_av(m) + surf_usm_h%wshf_eb(m)
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%wshf_eb_av(m) = surf_usm_h(l)%wshf_eb_av(m) + surf_usm_h(l)%wshf_eb(m)
                    ENDDO
                 ELSE
@@ -1711,7 +1663,7 @@
 !
 !--             Array of latent heat flux from surfaces (land, roof, wall)
-                IF ( l == -1 ) THEN
-                DO  m = 1, surf_usm_h%ns
-                   surf_usm_h%qsws_av(m) = surf_usm_h%qsws_av(m) + surf_usm_h%qsws(m) * l_v
+                IF ( horizontal ) THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   surf_usm_h(l)%qsws_av(m) = surf_usm_h(l)%qsws_av(m) + surf_usm_h(l)%qsws(m) * l_v
                 ENDDO
                 ELSE
@@ -1725,7 +1677,7 @@
 !
 !--             Array of latent heat flux from vegetation surfaces (land, roof, wall)
-                IF ( l == -1 )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   surf_usm_h%qsws_veg_av(m) = surf_usm_h%qsws_veg_av(m) + surf_usm_h%qsws_veg(m)
+                IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   surf_usm_h(l)%qsws_veg_av(m) = surf_usm_h(l)%qsws_veg_av(m) + surf_usm_h(l)%qsws_veg(m)
                 ENDDO
                 ELSE
@@ -1739,8 +1691,8 @@
 !
 !--             Array of latent heat flux from surfaces with liquid (land, roof, wall)
-                IF ( l == -1 ) THEN
-                DO  m = 1, surf_usm_h%ns
-                   surf_usm_h%qsws_liq_av(m) = surf_usm_h%qsws_liq_av(m) +                         &
-                                               surf_usm_h%qsws_liq(m)
+                IF ( horizontal ) THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   surf_usm_h(l)%qsws_liq_av(m) = surf_usm_h(l)%qsws_liq_av(m) +                         &
+                                               surf_usm_h(l)%qsws_liq(m)
                 ENDDO
                 ELSE
@@ -1754,8 +1706,8 @@
 !
 !--             Array of heat flux from ground (wall, roof, land)
-                IF ( l == -1 ) THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%wghf_eb_av(m) = surf_usm_h%wghf_eb_av(m) +                        &
-                                                 surf_usm_h%wghf_eb(m)
+                IF ( horizontal ) THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%wghf_eb_av(m) = surf_usm_h(l)%wghf_eb_av(m) +                        &
+                                                 surf_usm_h(l)%wghf_eb(m)
                    ENDDO
                 ELSE
@@ -1769,8 +1721,8 @@
 !
 !--             Array of heat flux from window ground (wall, roof, land)
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%wghf_eb_window_av(m) = surf_usm_h%wghf_eb_window_av(m) +          &
-                                                        surf_usm_h%wghf_eb_window(m)
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%wghf_eb_window_av(m) = surf_usm_h(l)%wghf_eb_window_av(m) +          &
+                                                        surf_usm_h(l)%wghf_eb_window(m)
                    ENDDO
                 ELSE
@@ -1784,8 +1736,8 @@
 !
 !--             Array of heat flux from green ground (wall, roof, land)
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%wghf_eb_green_av(m) = surf_usm_h%wghf_eb_green_av(m) +            &
-                                                       surf_usm_h%wghf_eb_green(m)
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%wghf_eb_green_av(m) = surf_usm_h(l)%wghf_eb_green_av(m) +            &
+                                                       surf_usm_h(l)%wghf_eb_green(m)
                    ENDDO
                 ELSE
@@ -1799,7 +1751,7 @@
 !
 !--             Array of heat flux from indoor ground (wall, roof, land)
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%iwghf_eb_av(m) = surf_usm_h%iwghf_eb_av(m) + surf_usm_h%iwghf_eb(m)
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%iwghf_eb_av(m) = surf_usm_h(l)%iwghf_eb_av(m) + surf_usm_h(l)%iwghf_eb(m)
                    ENDDO
                 ELSE
@@ -1813,8 +1765,8 @@
 !
 !--             Array of heat flux from indoor window ground (wall, roof, land)
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%iwghf_eb_window_av(m) = surf_usm_h%iwghf_eb_window_av(m) +        &
-                                                         surf_usm_h%iwghf_eb_window(m)
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%iwghf_eb_window_av(m) = surf_usm_h(l)%iwghf_eb_window_av(m) +        &
+                                                         surf_usm_h(l)%iwghf_eb_window(m)
                    ENDDO
                 ELSE
@@ -1828,12 +1780,12 @@
 !
 !--             Surface temperature for surfaces
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                   surf_usm_h%t_surf_wall_av(m) = surf_usm_h%t_surf_wall_av(m) + t_surf_wall_h(m)
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                   surf_usm_h(l)%t_surf_wall_av(m) = surf_usm_h(l)%t_surf_wall_av(m) + t_surf_wall_h(l)%val(m)
                    ENDDO
                 ELSE
                    DO  m = 1, surf_usm_v(l)%ns
                       surf_usm_v(l)%t_surf_wall_av(m) = surf_usm_v(l)%t_surf_wall_av(m) +          &
-                                                        t_surf_wall_v(l)%t(m)
+                                                        t_surf_wall_v(l)%val(m)
                    ENDDO
                 ENDIF
@@ -1842,13 +1794,13 @@
 !
 !--             Surface temperature for window surfaces
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%t_surf_window_av(m) = surf_usm_h%t_surf_window_av(m) +            &
-                                                       t_surf_window_h(m)
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%t_surf_window_av(m) = surf_usm_h(l)%t_surf_window_av(m) +            &
+                                                       t_surf_window_h(l)%val(m)
                    ENDDO
                 ELSE
                    DO  m = 1, surf_usm_v(l)%ns
                       surf_usm_v(l)%t_surf_window_av(m) = surf_usm_v(l)%t_surf_window_av(m) +      &
-                                                          t_surf_window_v(l)%t(m)
+                                                          t_surf_window_v(l)%val(m)
                    ENDDO
                 ENDIF
@@ -1857,13 +1809,13 @@
 !
 !--             Surface temperature for green surfaces
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%t_surf_green_av(m) = surf_usm_h%t_surf_green_av(m) +              &
-                                                      t_surf_green_h(m)
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%t_surf_green_av(m) = surf_usm_h(l)%t_surf_green_av(m) +              &
+                                                      t_surf_green_h(l)%val(m)
                    ENDDO
                 ELSE
                    DO  m = 1, surf_usm_v(l)%ns
                       surf_usm_v(l)%t_surf_green_av(m) = surf_usm_v(l)%t_surf_green_av(m) +        &
-                                                         t_surf_green_v(l)%t(m)
+                                                         t_surf_green_v(l)%val(m)
                    ENDDO
                 ENDIF
@@ -1872,8 +1824,8 @@
 !
 !--             Near surface temperature for whole surfaces
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%pt_10cm_av(m) = surf_usm_h%pt_10cm_av(m) +                        &
-                                                 surf_usm_h%pt_10cm(m)
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%pt_10cm_av(m) = surf_usm_h(l)%pt_10cm_av(m) +                        &
+                                                 surf_usm_h(l)%pt_10cm(m)
                    ENDDO
                 ELSE
@@ -1887,13 +1839,13 @@
 !
 !--             Wall temperature for  iwl layer of walls and land
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%t_wall_av(iwl,m) = surf_usm_h%t_wall_av(iwl,m) +                  &
-                                                    t_wall_h(iwl,m)
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%t_wall_av(iwl,m) = surf_usm_h(l)%t_wall_av(iwl,m) +                  &
+                                                    t_wall_h(l)%val(iwl,m)
                    ENDDO
                 ELSE
                    DO  m = 1, surf_usm_v(l)%ns
                       surf_usm_v(l)%t_wall_av(iwl,m) = surf_usm_v(l)%t_wall_av(iwl,m) +            &
-                                                       t_wall_v(l)%t(iwl,m)
+                                                       t_wall_v(l)%val(iwl,m)
                    ENDDO
                 ENDIF
@@ -1902,13 +1854,13 @@
 !
 !--             Window temperature for  iwl layer of walls and land
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%t_window_av(iwl,m) = surf_usm_h%t_window_av(iwl,m) +              &
-                                                      t_window_h(iwl,m)
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%t_window_av(iwl,m) = surf_usm_h(l)%t_window_av(iwl,m) +              &
+                                                         t_window_h(l)%val(iwl,m)
                    ENDDO
                 ELSE
                    DO  m = 1, surf_usm_v(l)%ns
                       surf_usm_v(l)%t_window_av(iwl,m) = surf_usm_v(l)%t_window_av(iwl,m) +        &
-                                                         t_window_v(l)%t(iwl,m)
+                                                         t_window_v(l)%val(iwl,m)
                    ENDDO
                 ENDIF
@@ -1917,12 +1869,12 @@
 !
 !--             Green temperature for  iwl layer of walls and land
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%t_green_av(iwl,m) = surf_usm_h%t_green_av(iwl,m) + t_green_h(iwl,m)
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%t_green_av(iwl,m) = surf_usm_h(l)%t_green_av(iwl,m) + t_green_h(l)%val(iwl,m)
                    ENDDO
                 ELSE
                    DO  m = 1, surf_usm_v(l)%ns
                       surf_usm_v(l)%t_green_av(iwl,m) = surf_usm_v(l)%t_green_av(iwl,m) +          &
-                                                        t_green_v(l)%t(iwl,m)
+                                                        t_green_v(l)%val(iwl,m)
                    ENDDO
                 ENDIF
@@ -1931,7 +1883,7 @@
 !
 !--             Soil water content for  iwl layer of walls and land
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%swc_av(iwl,m) = surf_usm_h%swc_av(iwl,m) + swc_h(iwl,m)
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%swc_av(iwl,m) = surf_usm_h(l)%swc_av(iwl,m) + swc_h(l)%val(iwl,m)
                    ENDDO
                 ELSE
@@ -1950,7 +1902,7 @@
 !
 !--             Array of sensible heat flux from surfaces (land, roof, wall)
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%wshf_eb_av(m) = surf_usm_h%wshf_eb_av(m) /                        &
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%wshf_eb_av(m) = surf_usm_h(l)%wshf_eb_av(m) /                        &
                                                  REAL( average_count_3d, kind=wp )
                    ENDDO
@@ -1965,7 +1917,7 @@
 !
 !--             Array of latent heat flux from surfaces (land, roof, wall)
-                IF ( l == -1 )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   surf_usm_h%qsws_av(m) = surf_usm_h%qsws_av(m) /                                 &
+                IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   surf_usm_h(l)%qsws_av(m) = surf_usm_h(l)%qsws_av(m) /                                 &
                                            REAL( average_count_3d, kind=wp )
                 ENDDO
@@ -1980,7 +1932,7 @@
 !
 !--             Array of latent heat flux from vegetation surfaces (land, roof, wall)
-                IF ( l == -1 )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   surf_usm_h%qsws_veg_av(m) = surf_usm_h%qsws_veg_av(m) /                         &
+                IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   surf_usm_h(l)%qsws_veg_av(m) = surf_usm_h(l)%qsws_veg_av(m) /                         &
                                                REAL( average_count_3d, kind=wp )
                 ENDDO
@@ -1995,7 +1947,7 @@
 !
 !--             Array of latent heat flux from surfaces with liquid (land, roof, wall)
-                IF ( l == -1 )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   surf_usm_h%qsws_liq_av(m) = surf_usm_h%qsws_liq_av(m) /                         &
+                IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   surf_usm_h(l)%qsws_liq_av(m) = surf_usm_h(l)%qsws_liq_av(m) /                         &
                                                REAL( average_count_3d, kind=wp )
                 ENDDO
@@ -2010,7 +1962,7 @@
 !
 !--             Array of heat flux from ground (wall, roof, land)
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%wghf_eb_av(m) = surf_usm_h%wghf_eb_av(m) /                        &
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%wghf_eb_av(m) = surf_usm_h(l)%wghf_eb_av(m) /                        &
                                                  REAL( average_count_3d, kind=wp )
                    ENDDO
@@ -2025,7 +1977,7 @@
 !
 !--             Array of heat flux from window ground (wall, roof, land)
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%wghf_eb_window_av(m) = surf_usm_h%wghf_eb_window_av(m) /          &
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%wghf_eb_window_av(m) = surf_usm_h(l)%wghf_eb_window_av(m) /          &
                                                         REAL( average_count_3d, kind=wp )
                    ENDDO
@@ -2040,7 +1992,7 @@
 !
 !--             Array of heat flux from green ground (wall, roof, land)
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%wghf_eb_green_av(m) = surf_usm_h%wghf_eb_green_av(m) /            &
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%wghf_eb_green_av(m) = surf_usm_h(l)%wghf_eb_green_av(m) /            &
                                                        REAL( average_count_3d, kind=wp )
                    ENDDO
@@ -2055,7 +2007,7 @@
 !
 !--             Array of heat flux from indoor ground (wall, roof, land)
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%iwghf_eb_av(m) = surf_usm_h%iwghf_eb_av(m) /                      &
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%iwghf_eb_av(m) = surf_usm_h(l)%iwghf_eb_av(m) /                      &
                                                   REAL( average_count_3d, kind=wp )
                    ENDDO
@@ -2070,7 +2022,7 @@
 !
 !--             Array of heat flux from indoor window ground (wall, roof, land)
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%iwghf_eb_window_av(m) = surf_usm_h%iwghf_eb_window_av(m) /        &
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%iwghf_eb_window_av(m) = surf_usm_h(l)%iwghf_eb_window_av(m) /        &
                                                          REAL( average_count_3d, kind=wp )
                    ENDDO
@@ -2085,7 +2037,7 @@
 !
 !--             Surface temperature for surfaces
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                   surf_usm_h%t_surf_wall_av(m) = surf_usm_h%t_surf_wall_av(m) /                   &
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                   surf_usm_h(l)%t_surf_wall_av(m) = surf_usm_h(l)%t_surf_wall_av(m) /                   &
                                                   REAL( average_count_3d, kind=wp )
                    ENDDO
@@ -2100,7 +2052,7 @@
 !
 !--             Surface temperature for window surfaces
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%t_surf_window_av(m) = surf_usm_h%t_surf_window_av(m) /            &
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%t_surf_window_av(m) = surf_usm_h(l)%t_surf_window_av(m) /            &
                                                        REAL( average_count_3d, kind=wp )
                    ENDDO
@@ -2115,7 +2067,7 @@
 !
 !--             Surface temperature for green surfaces
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%t_surf_green_av(m) = surf_usm_h%t_surf_green_av(m) /              &
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%t_surf_green_av(m) = surf_usm_h(l)%t_surf_green_av(m) /              &
                                                       REAL( average_count_3d, kind=wp )
                    ENDDO
@@ -2130,7 +2082,7 @@
 !
 !--             Near surface temperature for whole surfaces
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%pt_10cm_av(m) = surf_usm_h%pt_10cm_av(m) /                        &
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%pt_10cm_av(m) = surf_usm_h(l)%pt_10cm_av(m) /                        &
                                                  REAL( average_count_3d, kind=wp )
                    ENDDO
@@ -2146,7 +2098,7 @@
 !
 !--             Wall temperature for  iwl layer of walls and land
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%t_wall_av(iwl,m) = surf_usm_h%t_wall_av(iwl,m) /                  &
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%t_wall_av(iwl,m) = surf_usm_h(l)%t_wall_av(iwl,m) /                  &
                                                     REAL( average_count_3d, kind=wp )
                    ENDDO
@@ -2161,7 +2113,7 @@
 !
 !--             Window temperature for  iwl layer of walls and land
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%t_window_av(iwl,m) = surf_usm_h%t_window_av(iwl,m) /              &
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%t_window_av(iwl,m) = surf_usm_h(l)%t_window_av(iwl,m) /              &
                                                       REAL( average_count_3d, kind=wp )
                    ENDDO
@@ -2176,7 +2128,7 @@
 !
 !--             Green temperature for  iwl layer of walls and land
-                IF ( l == -1 )  THEN
-                   DO  m = 1, surf_usm_h%ns
-                      surf_usm_h%t_green_av(iwl,m) = surf_usm_h%t_green_av(iwl,m) /                &
+                IF ( horizontal )  THEN
+                   DO  m = 1, surf_usm_h(l)%ns
+                      surf_usm_h(l)%t_green_av(iwl,m) = surf_usm_h(l)%t_green_av(iwl,m) /                &
                                                      REAL( average_count_3d, kind=wp )
                    ENDDO
@@ -2191,7 +2143,7 @@
 !
 !--             Soil water content for  iwl layer of walls and land
-                IF ( l == -1 )  THEN
-                DO  m = 1, surf_usm_h%ns
-                   surf_usm_h%swc_av(iwl,m) = surf_usm_h%swc_av(iwl,m) /                           &
+                IF ( horizontal )  THEN
+                DO  m = 1, surf_usm_h(l)%ns
+                   surf_usm_h(l)%swc_av(iwl,m) = surf_usm_h(l)%swc_av(iwl,m) /                           &
                                               REAL( average_count_3d, kind=wp )
                 ENDDO
@@ -2208,6 +2160,4 @@
     ENDIF
 
-    ENDIF
-
  END SUBROUTINE usm_3d_data_averaging
 
@@ -2232,10 +2182,12 @@
     INTEGER(iwp) ::  m      !< running index surface elements
 
-    koff = surf_usm_h%koff
-    DO  m = 1, surf_usm_h%ns
-       i = surf_usm_h%i(m)
-       j = surf_usm_h%j(m)
-       k = surf_usm_h%k(m)
-       pt(k+koff,j,i) = pt(k,j,i)
+    DO  l = 0, 1
+       koff = surf_usm_h(l)%koff
+       DO  m = 1, surf_usm_h(l)%ns
+          i = surf_usm_h(l)%i(m)
+          j = surf_usm_h(l)%j(m)
+          k = surf_usm_h(l)%k(m)
+          pt(k+koff,j,i) = pt(k,j,i)
+       ENDDO
     ENDDO
 
@@ -2297,8 +2249,4 @@
                 'usm_t_window                  ', &
                 'usm_t_green                   '/)
-
-    INTEGER(iwp), PARAMETER                       ::  nd = 5     !< number of directions
-    CHARACTER(LEN=6), DIMENSION(nd), PARAMETER    ::  dirname = &  !< direction names
-              (/'_roof ','_south','_north','_west ','_east '/)
 
     LOGICAL                                       ::  lfound     !< flag if the variable is found
@@ -2415,11 +2363,4 @@
        message_string = 'topography /= "flat" is required when using the urban surface model'
        CALL message( 'usm_check_parameters', 'PA0592', 1, 2, 0, 6, 0 )
-    ENDIF
-!
-!-- Naheatlayers
-    IF ( naheatlayers > nzt )  THEN
-       message_string = 'number of anthropogenic heat layers "naheatlayers" can not be larger ' // &
-                        'than number of domain layers "nzt"'
-       CALL message( 'usm_check_parameters', 'PA0593', 1, 2, 0, 6, 0 )
     ENDIF
 !
